//UtilBroker is created in common.js - no need to create another instance
//var UtilBroker = Components.classes["component://netscape/utilitybroker"].createInstance();
//UtilBroker = UtilBroker.QueryInterface(Components.interfaces.hpIUtilityBroker);

var matches="Suche ergab 0 bereinstimmungen fr ";
var concatenateString="ist ein sehr hufiges Wort und wurde in der Suchanfrage ignoriert.";
var differentSearch="Bitte geben Sie andere Wrter ein, und fhren Sie erneut eine Suche durch.";
var searchHits = "Suchergebnisse"
var searchResult = "<B>Suche</B> ergab <B>$SEARCH_HITS$</B> bereinstimmungen fr <B>$SEARCH_TERMS$</B>"

function Search()
{
	var inputSearchTerms=document.getElementsByTagName("input").item(0);
	LogMessage("Search Terms: " + inputSearchTerms.value);
	var searchResult=new Object();
	searchResult.value=0;

	//remove leading whitespace
	inputSearchTerms.value=inputSearchTerms.value.replace(/^\s+/,"")

	if(inputSearchTerms.value != "")
	{
		UtilBroker.HPDugoutSearch(inputSearchTerms.value,true, searchResult);
	}
	else
	{
		searchResult.value=1;
	}

	if(searchResult.value==0)
	{
		top.location.replace("search_results_frameset.html");
	}
	else 
	{
		var divElements=document.getElementsByTagName("div");
		var divElement=null;
		var searchResultText=null;
		var elmtStopWord=null;

		if(searchResult.value < 0)
			searchResultText= GetSearchResultString("SearchErrorStr");

		for(var count=0 ; count < divElements.length ; count++)
		{
			if(divElements[count].getAttribute("id")=="SearchResults")
				divElement=divElements[count];

			if(searchResult.value > 0)
			{
				if(divElements[count].getAttribute("id")=="Layer1")
				{
					var inputElement=divElements[count].getElementsByTagName("input").item(0);
					if(inputElement && (inputElement.value != ""))
					{
						searchResultText= GetSearchResultString("NoMatchStr",inputElement.value);

						if(searchResult.value==2)
						{
							elmtStopWord=document.createElement("p");
							elmtStopWord.appendChild(document.createTextNode(GetSearchResultString("StopWordStr",inputElement.value)));
						}
					}
					else
						searchResultText= GetSearchResultString("NoMatchStr","");
				}
			}
		}

		if(divElement!=null)
		{
			while(divElement.lastChild)
				divElement.removeChild(divElement.lastChild);
			divElement.appendChild(document.createTextNode(searchResultText));
			if(elmtStopWord != null)
				divElement.appendChild(elmtStopWord);
		}
		else
		{
			var docBody=document.getElementsByTagName("body").item(0);

			divElement=document.createElement("div");
			divElement.setAttribute("id","SearchResults");
			divElement.setAttribute("style","position:absolute; left:170px; top:275px; width:340px; height:48px; z-index:1; visibility: visible");
			divElement.setAttribute("class","searchResultText");
			divElement.appendChild(document.createTextNode(searchResultText));
			if(elmtStopWord != null)
				divElement.appendChild(elmtStopWord);
			docBody.appendChild(divElement);
		}

		if(elmtStopWord != null)
			SetScreenReaderText(searchResultText + elmtStopWord);
		else
			SetScreenReaderText(searchResultText);
	}
}

function Hilite(bIsPhrase, sHTMLpage, sSearchTerms)
{
	dump("inside Hilite\n");
	var bReturn  = new Object();
	var sHilitedHTMLpage = new Object();
	UtilBroker.HPHilite(bIsPhrase, sHTMLpage, sSearchTerms, sHilitedHTMLpage, bReturn);

   // top sets to top window, not the frame window
	if(bReturn.value)
	{
		// success. Launch new page
		dump("HPhilite OK\n");
		dump("HTML page: " + sHilitedHTMLpage.value + "\n");

		// only keep filename. The dugout protocol handler will look
		// in the cache first for this file (and find it)

		var sFile = sHilitedHTMLpage.value.match(/\w+\.\w+$/);
		//dump(sFile + "\n");
		top.location = sFile;
	}
	else
	{
		// failure
		dump("HPhilite failed\n");
	}
}

function GetSearchResultString()
{
	var RetStr="";

	if(GetSearchResultString.arguments[0]=="NoMatchStr")								  
		RetStr= matches + '"' + GetSearchResultString.arguments[1] + '"';
	else if(GetSearchResultString.arguments[0]=="StopWordStr")
	  	RetStr='"' + GetSearchResultString.arguments[1] + '"' + concatenateString;
	else
		RetStr= differentSearch;

	return RetStr;
}

function GetSearchHitsString()
{
	var returnValue = new Object();
	var outString = new Object();

	var inString = new String();
    inString.value = '<P class="bodyText">' + searchResult + "</P>"; 

	switch(GetMacroValue("LANG").toLowerCase())
	{
		case "chs":
		case "cht":
		case "jpn":
		case "kor":
		case "rus":
		case "tha":
			UtilBroker.HPExpandStringW(inString.value,outString,returnValue);
			break;

		default:
			UtilBroker.HPExpandString(inString.value,outString,returnValue);
	}

	if(returnValue.value)	
	{
		//success
		document.write( outString.value );
	}
}

function GetSearchHitsTitle()
{
	document.write( "<TITLE>" + searchHits + "</TITLE>" );
}

